program Flash;
{ Simple Screen Saver by Alexander Malygin (2:4641/41.73) }

uses Drivers,Objects;

var
  SourceBuffer : PWordArray;
  BufSize : word;
  VideoBuffer : PWordArray absolute ScreenBuffer;
  RowIndex,
  MaxRowIndex : integer;
  Event : TEvent;
  W,H,CorrectY : integer;
  Time : longint;

const
  X : integer = 0;
  Y : integer = 0;
  J : integer = 0;
  FlashMode : boolean = false;
  Delay = 4;

function DosTimer : longint; assembler;
  asm
    mov   ax, Seg0040
    mov   es, ax
    cli
    mov   ax, es:[$6C]
    mov   dx, es:[$6E]
    sti
  end;

procedure CopyBuf(XS,YS,XD,YD,SizeX,SizeY : integer);
  var I : integer;
  begin
    inc(Xs, Ys*ScreenWidth);
    inc(Xd, Yd*ScreenWidth);
    for i := 0 to sizey-1 do
      begin
        move(SourceBuffer^[Xs], VideoBuffer^[Xd], SizeX shl 1);
        inc(Xs, ScreenWidth);
        inc(Xd, ScreenWidth);
      end;
  end;

begin
  InitEvents;
  InitVideo;
  BufSize := (ScreenWidth * ScreenHeight) shl 1;
  getmem(SourceBuffer, BufSize);
  move(ScreenBuffer^, SourceBuffer^, BufSize);
  MaxRowIndex := (ScreenHeight-1) * ScreenWidth;
  W := ScreenWidth shr 1;
  H := ScreenHeight shr 1 + ord(odd(ScreenHeight));
  Event.What := evNothing;
  HideMouse;
  Time := DosTimer;
  repeat
    if Time < DosTimer then
      begin
        if x <> w then inc(x);
        if y <> h then if not odd(x) then inc(y);
        if FlashMode then
          begin
            CopyBuf(0, 0, W-X, H-Y, x, y);
            CopyBuf(ScreenWidth-X, 0, W, H-Y, x, y);
            CorrectY := y - ord((y = h) and odd(ScreenHeight));
            CopyBuf(0, ScreenHeight-CorrectY, W-X, H, x, CorrectY);
            CopyBuf(ScreenWidth-X, ScreenHeight-CorrectY, W, H, x, CorrectY);
          end
        else
          begin
            RowIndex := (y-1) * ScreenWidth;
            for j := 0 to ScreenWidth-1 do
              begin
                VideoBuffer^[RowIndex + j] := 0;
                VideoBuffer^[MaxRowIndex - RowIndex + j] := 0;
              end;
            for j := y-1 to ScreenHeight-y do
              begin
                VideoBuffer^[x-1 + j*ScreenWidth] := 0;
                VideoBuffer^[ScreenWidth - x + j*ScreenWidth] := 0;
              end;
          end;
        if(Y = H) and
          ((FlashMode and (X = W) or
          (not FlashMode and (W - X < (W - H + 1))))) then
          begin
            x := 0; y := 0;
            if FlashMode then inc(Time, 15);
            FlashMode := not FlashMode;
          end;
        inc(Time, Delay);
      end;
    GetKeyEvent(Event);
    if Event.What = evNothing then GetMouseEvent(Event);
  until Event.What <> evNothing;
  ShowMouse;
  DoneVideo;
  DoneEvents;
  move(SourceBuffer^, ScreenBuffer^, BufSize);
  freemem(SourceBuffer, BufSize);
end.

